/***********************************************************************
 * Copyright(c) 2013~2015 El Condor
 * 25 3 2015 
 * thanks to Donal Morrissey - 2011.
 ***********************************************************************/
#include <avr/sleep.h>
#include <avr/power.h>
volatile bool f_timer = false;  // flag for timeout
void enterSleep() {
  sleep_enable();
  power_adc_disable();          // disable
  power_spi_disable();          // some
  power_timer2_disable();       // unused
  power_twi_disable();          // peripherals
//  TCNT1 = 0x05FF;               // 4 seconds (i.e 0xFFFF - 0x(4000*16))
  TCNT1 = 0x447F;               // 3 seconds (i.e 0xFFFF - 0x(3000*16))
  f_timer = false;
  while (!f_timer) sleep_mode();  // Enter sleep mode
  sleep_disable();              // First thing to do is disable sleep
  power_all_enable();           // Re-enable the peripherals
}
ISR(TIMER1_OVF_vect) {          // interrupt handler
  f_timer = true;
}
void setup() {
  Serial.begin(9600);
  set_sleep_mode(SLEEP_MODE_IDLE);
  TCCR1A = 0x00;
  TCCR1B = 0x05;   // Prescaler for 1:1024, a timeout max of 4.09 seconds
  TIMSK1 = 0x01;   // Enable the timer overflow interrupt
}
void loop() {
  unsigned long timer = millis();
  enterSleep();
  Serial.print(millis() - timer);
  Serial.print(" ");
  Serial.println(millis());
}
