/***********************************************************************
 * Copyright(c) 2013~2015 El Condor
 * 27 3 2015 
 * thanks to Martin Nawrath and Donal Morrissey
 ***********************************************************************/
#include <avr/sleep.h>
#include <avr/wdt.h>
volatile unsigned long realTimer;
volatile boolean f_wdt = true;
void setup(){
  Serial.begin(9600);
  setup_watchdog(8);  // 4 seconds
}
void loop(){
  if (f_wdt) {  // wait for timed out watchdog, flag is set when a watchdog timeout occurs
    f_wdt = false;       // reset flag
    Serial.print(millis());    
    Serial.print("\t" );
    Serial.println(millis()+realTimer);
    delay(20);             // wait until the last serial character is send
    system_sleep();
    realTimer += 4000;
  }
}
//****************************************************************  
// set system into the sleep state 
// system wakes up when wtchdog is timed out
void system_sleep() {
  set_sleep_mode(SLEEP_MODE_PWR_DOWN);
  sleep_enable();
  sleep_mode();
  sleep_disable();             // System continues execution here when watchdog timed out 
}
//****************************************************************
// 0=16ms, 1=32ms,2=64ms,3=128ms,4=250ms,5=500ms
// 6=1 sec,7=2 sec, 8=4 sec, 9= 8sec
void setup_watchdog(int ii) {
  byte bb;
  if (ii > 9 ) ii=9;
  bb=ii & 7;
  if (ii > 7) bb|= (1<<5);
  bb|= (1<<WDCE);
  MCUSR &= ~(1<<WDRF);  // clear reset flag
  // start timed sequence
  WDTCSR |= (1<<WDCE) | (1<<WDE);
  // set new watchdog timeout value
  WDTCSR = bb;
  WDTCSR |= _BV(WDIE);
}
//****************************************************************  
// Watchdog Interrupt Service / is executed when  watchdog timed out
ISR(WDT_vect) {
  f_wdt = true;  // set global flag
}
